## brewtarget 1.2.3

=== CMakeLists.txt ===
PROJECT(brewtarget)
cmake_minimum_required(VERSION 2.8)

# Creates a Makefile.
# NOTE: cmake . -DCMAKE_INSTALL_PREFIX=/tmp/blah && make DESTDIR=/foo
# will install to /foo/tmp/blah.

# Where the binary goes.
SET(brewtarget_EXECUTABLE "brewtarget")

#=================================Version======================================
SET( brewtarget_VERSION_MAJOR 1 )
SET( brewtarget_VERSION_MINOR 2 )
SET( brewtarget_VERSION_PATCH 3 )
SET( brewtarget_VERSION_STRING "${brewtarget_VERSION_MAJOR}.${brewtarget_VERSION_MINOR}.${brewtarget_VERSION_PATCH}" )

#===================================Options====================================
OPTION( BUILD_DESIGNER_PLUGINS
        "If on, you will only build and install the designer plugins."
        OFF )
OPTION( DO_RELEASE_BUILD
        "If on, will do a release build. Otherwise, debug build."
        OFF )
OPTION( ENABLE_PROFILING
        "If on, builds with necessary profiling options."
        OFF )
OPTION( NO_PHONON
        "If on, does not build any Phonon code."
        OFF )
OPTION(UPDATE_TRANSLATIONS
       "Update source translation *.ts files (WARNING: 'make clean' will delete the source .ts files! Danger!)"
       OFF)
#==============================Compile flags===================================
SET( CMAKE_CXX_FLAGS_RELEASE "-Wall -ansi -pedantic -O2" )
SET( CMAKE_CXX_FLAGS_DEBUG "-Wall -gstabs+" )

IF( ${ENABLE_PROFILING} )
   SET( CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -pg" )
ENDIF()

IF( ${NO_PHONON} )
   ADD_DEFINITIONS( -DNO_PHONON )
ENDIF()

IF( ${DO_RELEASE_BUILD} )
   SET( CMAKE_BUILD_TYPE "Release" )
ELSE()
   SET( CMAKE_BUILD_TYPE "Debug" )
ENDIF()

IF( APPLE )
   SET( CMAKE_OSX_ARCHITECTURES ppc i386 ) # Build universal binary
   #SET( CMAKE_OSX_ARCHITECTURES ppc i386 ppc64 x86_64 ) # Build universal binary for 32 and 64 bit.
ENDIF()

#============================Directories=======================================
SET(ROOTDIR "${CMAKE_CURRENT_SOURCE_DIR}")
SET(SRCDIR "${ROOTDIR}/src")
SET(UIDIR "${ROOTDIR}/ui")
SET(DATADIR "${ROOTDIR}/data")
SET(TRANSLATIONSDIR "${ROOTDIR}/translations")
SET(WINDIR "${ROOTDIR}/win")

INCLUDE_DIRECTORIES(${SRCDIR})
INCLUDE_DIRECTORIES("${CMAKE_BINARY_DIR}/src") # In case of out-of-source build.
INCLUDE_DIRECTORIES("${CMAKE_BINARY_DIR}/QtDesignerPlugins")

# ======================Find Qt4 (>= 4.6.0) for this project===================
IF( ${BUILD_DESIGNER_PLUGINS} )
   FIND_PACKAGE(Qt4 4.6.0 COMPONENTS QtCore QtGui QtNetwork QtSvg QtWebKit QtXml Phonon QtDesigner REQUIRED)
ELSE()
   FIND_PACKAGE(Qt4 4.6.0 COMPONENTS QtCore QtGui QtNetwork QtSvg QtWebkit QtXml Phonon REQUIRED)
ENDIF()

# Some extra files for the "make clean" target.
SET_PROPERTY(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
             PROPERTY ADDITIONAL_MAKE_CLEAN_FILES
             ".*~$" # Kate backup files.
             "CMakeLists.txt.user" # From QtCreator I think.
             "CPackConfig.cmake"
             "CPackSourceConfig.cmake"
            )

#============================Doxygen Custom Target=============================
FIND_PROGRAM( DOXYGEN_CMD doxygen )
IF( DOXYGEN_CMD )
  ADD_CUSTOM_TARGET( source_doc
                     COMMAND ${DOXYGEN_CMD} Doxyfile
                     WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/doc"
                   )
ENDIF()

#=========================Detect Debian======================================== 
IF( EXISTS "/etc/debian_version" )
  MESSAGE( STATUS "Debian detected..." )

  IF( NOT ${CMAKE_INSTALL_PREFIX} STREQUAL "/usr" )
    MESSAGE( WARNING "Debian system, but CMAKE_INSTALL_PREFIX != /usr" )
    MESSAGE( WARNING "CMAKE_INSTALL_PREFIX = \"${CMAKE_INSTALL_PREFIX}\"" )
  ENDIF()
ENDIF()

#========================Construct the directories=============================

# Debian standard directories.
SET( EXEC_PREFIX ${CMAKE_INSTALL_PREFIX} )
SET( DATAROOTDIR "${CMAKE_INSTALL_PREFIX}/share" )
#SET( DATADIR ${DATAROOTDIR} )
SET( BINDIR "${EXEC_PREFIX}/bin" )
SET( DOCDIR "${DATAROOTDIR}/doc/${CMAKE_PROJECT_NAME}" )

# Actual install directories.
IF( UNIX AND NOT APPLE )
  SET( DATAPATH "${DATAROOTDIR}/${CMAKE_PROJECT_NAME}" )
  SET( TARGETPATH ${BINDIR} )
  SET( DOCPATH ${DOCDIR} )
ELSEIF( WIN32 )
  SET( DATAPATH "${CMAKE_INSTALL_PREFIX}/release" )
  SET( TARGETPATH "${CMAKE_INSTALL_PREFIX}/release" )
  SET( DOCPATH "${CMAKE_INSTALL_PREFIX}/release/doc" )
ELSEIF( APPLE )
  SET( DATAPATH "Resources" )
  SET( DOCPATH  "Resources/en.lproj" )
ENDIF()

# DATAPATH=/usr/share/brewtarget
#MESSAGE( STATUS "DATAPATH=${DATAPATH}" )

#==============================Setup the config.h==============================

# "#define CONFIGDATADIR ${CONFIGDATADIR}$" in config.in will be replaced
# by the below corresponding value in ${CONFIGDATADIR} below when
# CONFIGURE_FILE() is called.
SET( CONFIGDATADIR "${DATAPATH}/" )
SET( CONFIGDOCDIR "${DOCPATH}/" )

# Tell cmake where the configure file is and where
# to put the output. All variables in config.in written as "${VAR}$
# will be replaced by VAR as determined by cmake in config.h.
CONFIGURE_FILE( "${SRCDIR}/config.in" "${SRCDIR}/config.h" )


# =====================Process other CMakeList.txt's===========================
IF( ${BUILD_DESIGNER_PLUGINS} )
   MESSAGE( STATUS "Building Qt Designer plugins." )
   ADD_SUBDIRECTORY(QtDesignerPlugins)
ELSE()
   MESSAGE( STATUS "Building Brewtarget." )
   ADD_SUBDIRECTORY(${SRCDIR})
ENDIF()

=== src/CMakeLists.txt ===
# Put all the required Qt dirs in the includes.
INCLUDE(${QT_USE_FILE})

# Variable that contains all the .cpp files in this project.
SET( brewtarget_SRCS
    ${SRCDIR}/Algorithms.cpp
    ${SRCDIR}/database.cpp
    ${SRCDIR}/BeerXMLElement.cpp
    ${SRCDIR}/BrewDayWidget.cpp
    ${SRCDIR}/BrewDayScrollWidget.cpp
    ${SRCDIR}/BeerColorWidget.cpp
    ${SRCDIR}/brewtarget.cpp
    ${SRCDIR}/CelsiusTempUnitSystem.cpp
    ${SRCDIR}/ColorMethods.cpp
    ${SRCDIR}/ConverterTool.cpp
    ${SRCDIR}/equipment.cpp
    ${SRCDIR}/EquipmentComboBox.cpp
    ${SRCDIR}/EquipmentEditor.cpp
    ${SRCDIR}/FahrenheitTempUnitSystem.cpp
    ${SRCDIR}/fermentable.cpp
    ${SRCDIR}/FermentableEditor.cpp
    ${SRCDIR}/FermentableDialog.cpp
    ${SRCDIR}/FermentableSortFilterProxyModel.cpp
    ${SRCDIR}/FermentableTableModel.cpp
    ${SRCDIR}/FermentableTableWidget.cpp
    ${SRCDIR}/main.cpp
    ${SRCDIR}/HeatCalculations.cpp
    ${SRCDIR}/hop.cpp
    ${SRCDIR}/HopDialog.cpp
    ${SRCDIR}/HopEditor.cpp
    ${SRCDIR}/HopSortFilterProxyModel.cpp
    ${SRCDIR}/HopTableModel.cpp
    ${SRCDIR}/HopTableWidget.cpp
    ${SRCDIR}/HtmlViewer.cpp
    ${SRCDIR}/instruction.cpp
    ${SRCDIR}/IbuMethods.cpp
    ${SRCDIR}/ImperialVolumeUnitSystem.cpp
    ${SRCDIR}/InstructionWidget.cpp
    ${SRCDIR}/MainWindow.cpp
    ${SRCDIR}/MaltinessWidget.cpp
    ${SRCDIR}/mash.cpp
    ${SRCDIR}/MashComboBox.cpp
    ${SRCDIR}/MashEditor.cpp
    ${SRCDIR}/mashstep.cpp
    ${SRCDIR}/MashStepEditor.cpp
    ${SRCDIR}/MashStepTableModel.cpp
    ${SRCDIR}/MashStepTableWidget.cpp
    ${SRCDIR}/MashWizard.cpp
    ${SRCDIR}/matrix.cpp
    ${SRCDIR}/misc.cpp
    ${SRCDIR}/MiscEditor.cpp
    ${SRCDIR}/MiscDialog.cpp
    ${SRCDIR}/MiscSortFilterProxyModel.cpp
    ${SRCDIR}/MiscTableModel.cpp
    ${SRCDIR}/MiscTableWidget.cpp
    ${SRCDIR}/observable.cpp
    ${SRCDIR}/observer.cpp
    ${SRCDIR}/OgAdjuster.cpp
    ${SRCDIR}/OptionDialog.cpp
    ${SRCDIR}/PreInstruction.cpp
    ${SRCDIR}/PrimingDialog.cpp
    ${SRCDIR}/recipe.cpp
    ${SRCDIR}/RecipeComboBox.cpp
    ${SRCDIR}/RecipeFormatter.cpp
    ${SRCDIR}/RefractoDialog.cpp
    ${SRCDIR}/ScaleRecipeTool.cpp
    ${SRCDIR}/SIVolumeUnitSystem.cpp
    ${SRCDIR}/SIWeightUnitSystem.cpp
    ${SRCDIR}/style.cpp
    ${SRCDIR}/StyleComboBox.cpp
    ${SRCDIR}/StyleEditor.cpp
    ${SRCDIR}/TimerListDialog.cpp
    ${SRCDIR}/TimerWidget.cpp
    ${SRCDIR}/TimeUnitSystem.cpp
    ${SRCDIR}/unit.cpp
    ${SRCDIR}/UnitSystems.cpp
    ${SRCDIR}/USVolumeUnitSystem.cpp
    ${SRCDIR}/USWeightUnitSystem.cpp
    ${SRCDIR}/water.cpp
    ${SRCDIR}/WaterTableModel.cpp
    ${SRCDIR}/WaterTableWidget.cpp
    ${SRCDIR}/WaterEditor.cpp
    ${SRCDIR}/yeast.cpp
    ${SRCDIR}/YeastDialog.cpp
    ${SRCDIR}/YeastEditor.cpp
    ${SRCDIR}/YeastTableModel.cpp
    ${SRCDIR}/YeastTableWidget.cpp
    ${SRCDIR}/YeastSortFilterProxyModel.cpp
    ${SRCDIR}/RecipeExtrasDialog.cpp
    ${SRCDIR}/MashDesigner.cpp
    ${SRCDIR}/BtDigitWidget.cpp
    ${SRCDIR}/PitchDialog.cpp
    ${SRCDIR}/RecipeExtrasWidget.cpp
)

# List of all the *.ui.
# TODO: can I somehow have a separate CMakeLists.txt
# in the ui/ directory instead of here?
SET( brewtarget_UIS
    ${UIDIR}/aboutDialog.ui
    ${UIDIR}/brewDayWidget.ui
    ${UIDIR}/brewDayScrollWidget.ui
    ${UIDIR}/converterTool.ui
    ${UIDIR}/mainWindow.ui
    ${UIDIR}/mashStepEditor.ui
    ${UIDIR}/miscEditor.ui
    ${UIDIR}/fermentableEditor.ui
    ${UIDIR}/fermentableDialog.ui
    ${UIDIR}/equipmentEditor.ui
    ${UIDIR}/hopDialog.ui
    ${UIDIR}/hopEditor.ui
    ${UIDIR}/htmlViewer.ui
    ${UIDIR}/instructionWidget.ui
    ${UIDIR}/mashEditor.ui
    ${UIDIR}/mashWizard.ui
    ${UIDIR}/miscDialog.ui
    ${UIDIR}/ogAdjuster.ui
    ${UIDIR}/optionsDialog.ui
    ${UIDIR}/primingDialog.ui
    ${UIDIR}/recipeExtrasDialog.ui
    ${UIDIR}/refractoDialog.ui
    ${UIDIR}/scaleRecipeTool.ui
    ${UIDIR}/styleEditor.ui
    ${UIDIR}/timerListDialog.ui
    ${UIDIR}/timerWidget.ui
    ${UIDIR}/waterEditor.ui
    ${UIDIR}/yeastDialog.ui
    ${UIDIR}/yeastEditor.ui
    ${UIDIR}/mashDesigner.ui
    ${UIDIR}/pitchDialog.ui
    ${UIDIR}/brewDayScrollWidget.ui
    ${UIDIR}/recipeExtrasWidget.ui
)

# The list of files that need to be moc'd.
# In other words, classes that have Q_OBJECT declarations and stuff.
SET( brewtarget_MOC_HEADERS
    ${SRCDIR}/BeerColorWidget.h
    ${SRCDIR}/BrewDayWidget.h
    ${SRCDIR}/BrewDayScrollWidget.h
    ${SRCDIR}/BtDigitWidget.h
    ${SRCDIR}/ConverterTool.h
    ${SRCDIR}/EquipmentComboBox.h
    ${SRCDIR}/EquipmentEditor.h
    ${SRCDIR}/FermentableEditor.h
    ${SRCDIR}/FermentableDialog.h
    ${SRCDIR}/FermentableSortFilterProxyModel.h
    ${SRCDIR}/FermentableTableModel.h
    ${SRCDIR}/FermentableTableWidget.h
    ${SRCDIR}/HopDialog.h
    ${SRCDIR}/HopEditor.h
    ${SRCDIR}/HopSortFilterProxyModel.h
    ${SRCDIR}/HopTableModel.h
    ${SRCDIR}/HopTableWidget.h
    ${SRCDIR}/InstructionWidget.h
    ${SRCDIR}/MainWindow.h
    ${SRCDIR}/MaltinessWidget.h
    ${SRCDIR}/MashComboBox.h
    ${SRCDIR}/MashDesigner.h
    ${SRCDIR}/MashEditor.h
    ${SRCDIR}/MashStepEditor.h
    ${SRCDIR}/MashStepTableModel.h
    ${SRCDIR}/MashStepTableWidget.h
    ${SRCDIR}/MashWizard.h
    ${SRCDIR}/MiscDialog.h
    ${SRCDIR}/MiscEditor.h
    ${SRCDIR}/MiscSortFilterProxyModel.h
    ${SRCDIR}/MiscTableModel.h
    ${SRCDIR}/MiscTableWidget.h
    ${SRCDIR}/OgAdjuster.h
    ${SRCDIR}/OptionDialog.h
    ${SRCDIR}/PitchDialog.h
    ${SRCDIR}/PrimingDialog.h
    ${SRCDIR}/RecipeComboBox.h
    ${SRCDIR}/RecipeExtrasDialog.h
    ${SRCDIR}/RecipeExtrasWidget.h
    ${SRCDIR}/RecipeFormatter.h
    ${SRCDIR}/RefractoDialog.h
    ${SRCDIR}/ScaleRecipeTool.h
    ${SRCDIR}/StyleComboBox.h
    ${SRCDIR}/StyleEditor.h
    ${SRCDIR}/TimerListDialog.h
    ${SRCDIR}/TimerWidget.h
    ${SRCDIR}/WaterTableModel.h
    ${SRCDIR}/WaterTableWidget.h
    ${SRCDIR}/WaterEditor.h
    ${SRCDIR}/YeastDialog.h
    ${SRCDIR}/YeastEditor.h
    ${SRCDIR}/YeastSortFilterProxyModel.h
    ${SRCDIR}/YeastTableModel.h
    ${SRCDIR}/YeastTableWidget.h
)

# List of documentation files to be installed.
SET( brewtarget_DOCS
     ${ROOTDIR}/README
#     ${ROOTDIR}/COPYING.GPLv3
#     ${ROOTDIR}/COPYING.WTFPL
     ${ROOTDIR}/COPYRIGHT
     ${ROOTDIR}/doc/manual/index.html
)

# List of data files to be installed.
SET( brewtarget_DATA
     ${DATADIR}/database.xml
     ${DATADIR}/mashs.xml
     ${DATADIR}/options.xml
     ${DATADIR}/recipes.xml
)

# Desktop files to install.
SET( brewtarget_DESKTOP
     ${ROOTDIR}/brewtarget.desktop
)

# Icon files to install.
SET( brewtarget_ICONS
     ${ROOTDIR}/images/BrewtargetIcon.png
)

SET( TRANSLATIONS_FILES
     ${TRANSLATIONSDIR}/bt_cs.ts # Czech
     ${TRANSLATIONSDIR}/bt_de.ts # German
     ${TRANSLATIONSDIR}/bt_en.ts # English
     ${TRANSLATIONSDIR}/bt_es.ts # Spanish
     ${TRANSLATIONSDIR}/bt_fr.ts # French
     ${TRANSLATIONSDIR}/bt_pl.ts # Polish
     ${TRANSLATIONSDIR}/bt_pt.ts # Portuguese
)

SET( FILES_TO_TRANSLATE
     ${brewtarget_SRCS}
     ${brewtarget_UIS}
)

SET( RCFILE ${WINDIR}/icon.rc )

SET( brewtarget_SOUNDS
     ${DATADIR}/sounds/45minLeft.mp3
     ${DATADIR}/sounds/addFuckinHops.mp3
     ${DATADIR}/sounds/aromaHops.mp3
     ${DATADIR}/sounds/bitteringHops.mp3
     ${DATADIR}/sounds/checkBoil.mp3
     ${DATADIR}/sounds/checkFirstRunnings.mp3
     ${DATADIR}/sounds/checkGravity.mp3
     ${DATADIR}/sounds/checkHydrometer.mp3
     ${DATADIR}/sounds/checkMashTemps.mp3
     ${DATADIR}/sounds/checkTemp.mp3
     ${DATADIR}/sounds/clarifyingAgent.mp3
     ${DATADIR}/sounds/cleanup.mp3
     ${DATADIR}/sounds/closeFuckinValves.mp3
     ${DATADIR}/sounds/closeValves.mp3
     ${DATADIR}/sounds/doughIn.mp3
     ${DATADIR}/sounds/drinkAnotherHomebrew.mp3
     ${DATADIR}/sounds/drinkHomebrew.mp3
     ${DATADIR}/sounds/emptyMashTun.mp3
     ${DATADIR}/sounds/extraPropane.mp3
     ${DATADIR}/sounds/flameout.mp3
     ${DATADIR}/sounds/flavorHops.mp3
     ${DATADIR}/sounds/heatWater.mp3
     ${DATADIR}/sounds/mashHops.mp3
     ${DATADIR}/sounds/pitchYeast.mp3
     ${DATADIR}/sounds/sanitize.mp3
     ${DATADIR}/sounds/sparge.mp3
     ${DATADIR}/sounds/startBurner.mp3
     ${DATADIR}/sounds/startChill.mp3
     ${DATADIR}/sounds/stirMash.mp3
)

#==================================Qt Junk=====================================

# Create the moc sources from the headers.
QT4_WRAP_CPP(brewtarget_MOC_SRCS ${brewtarget_MOC_HEADERS})

# Create the ui_*.h files from the *.ui files.
QT4_WRAP_UI(brewtarget_UIS_H ${brewtarget_UIS})

# Generate the resource .cpp from the .qrc file.
QT4_ADD_RESOURCES(brewtarget_QRC_CPP "../brewtarget.qrc")

# Translations
IF(UPDATE_TRANSLATIONS)
  # Updates the .ts files with translatable strings, AND creates the binary .qm files
  QT4_CREATE_TRANSLATION(QM_FILES
                         ${FILES_TO_TRANSLATE}
                         ${TRANSLATIONS_FILES}
  )
ELSE()
  # Creates the .qm files without modifying the .ts files.
  QT4_ADD_TRANSLATION(QM_FILES ${TRANSLATIONS_FILES})
ENDIF() 

# Add a target for the QM_FILES so that we can add
# the translations as a dependency for the executable later.
ADD_CUSTOM_TARGET(translations DEPENDS ${QM_FILES})

#===============================Packaging======================================

# NOTE: For now, this only calls CPack when we are unix. Need to add support
# for apple bundles and microsoft NSIS installer.
#
# To make the packages, "make package". For source packages, "make package_source"
IF(EXISTS "${CMAKE_ROOT}/Modules/CPack.cmake" AND UNIX AND NOT APPLE)
  MESSAGE(STATUS "CMakeRoot: ${CMAKE_ROOT}/Modules/CPack.cmake")

  SET(CPACK_SET_DESTDIR "on")
  SET(CPACK_PACKAGING_INSTALL_PREFIX "/tmp")
  SET(CPACK_SOURCE_GENERATOR "TBZ2;")
  SET(CPACK_SOURCE_IGNORE_FILES 
      "/.svn/"
      "~$"
      "/CMakeFiles/"
      "/_CPack_Packages/"
      "^brewtarget.*deb$"
      "^brewtarget.*rpm$"
      "^brewtarget.*tar.*$"
      "CPack.*"
      "Makefile"
      "cmake_install.*"
      "\\\\.o$"
      "/brewtarget.dir/"
      "moc_.*"
      "qrc_brewtarget.*"
      "ui_.*h"
      "install_manifest.*"
      "config\\\\.h"
  )

  SET( CPACK_PACKAGE_VERSION ${brewtarget_VERSION_STRING} )
  SET( CPACK_PACKAGE_VENDOR  "Philip G. Lee" )
  SET( CPACK_PACKAGE_CONTACT "Philip G. Lee <rocketman768@gmail.com>" )
  SET( CPACK_PACKAGE_DESCRIPTION_SUMMARY "GUI beer brewing software" )
  SET( CPACK_PACKAGE_DESCRIPTION "Brewtarget is a calculator for brewing beer. It is a Qt-based program which
       allows you to create recipes from a database of ingredients. It calculates all
       the important parameters, helps you with mash temperatures, and just makes the
       process of recipe formulation much easier." )

#	SET(CPACK_RESOURCE_FILE_LICENSE		${CMAKE_CURRENT_SOURCE_DIR}//COPYING)
  SET(CPACK_PACKAGE_VERSION_MAJOR       ${brewtarget_VERSION_MAJOR})
  SET(CPACK_PACKAGE_VERSION_MINOR       ${brewtarget_VERSION_MINOR})	# to create a debian confirm file-version-string
  SET(CPACK_PACKAGE_FILE_NAME           "${CMAKE_PROJECT_NAME}_${brewtarget_VERSION_STRING}_${CMAKE_SYSTEM_PROCESSOR}")
  SET(CPACK_SOURCE_PACKAGE_FILE_NAME    "${CMAKE_PROJECT_NAME}_${brewtarget_VERSION_STRING}_source")
  SET(CPACK_PACKAGE_EXECUTABLES "${brewtarget_EXECUTABLE}" "Brewtarget" )
  #SET(CPACK_STRIP_FILES TRUE)
  SET(CPACK_COMPONENTS_ALL Libraries ApplicationData)

 #===========================UNIX======================================
 IF(UNIX)
  SET(CPACK_GENERATOR "DEB;RPM;TBZ2;")

  #-----------------DEB----------------
  SET( CPACK_DEBIAN_PACKAGE_MAINTAINER "Philip G. Lee <rocketman768@gmail.com>" )
  # NOTE: Use the getdependencies script to get the dependencies!
  SET( CPACK_DEBIAN_PACKAGE_DEPENDS "libc6 (>= 2.3.6-6~), libc6 (>= 2.4), libgcc1 (>= 1:4.1.1), libphonon4 (>= 4:4.2.0), libqt4-dbus (>= 4:4.5.3), libqt4-svg (>= 4:4.5.3), libqt4-webkit (>= 4:4.5.3), libqt4-xml (>= 4:4.5.3), libqtcore4 (>= 4:4.6.1), libqtgui4 (>= 4:4.5.3), libstdc++6 (>= 4.1.1), libx11-6, phonon (>= 4:4.5.2)" )

  SET( CPACK_DEBIAN_PACKAGE_SECTION "misc" )

=== debian/changelog ===
brewtarget (1.2.3-1.1ubuntu1) oneiric; urgency=low

  * Fix FTBFS (LP: #831250)
    - Add 05-ubuntu-phonon: Apply upstream SVN revisions 510 and 512.
      Then reorder the Phonon check so that it precedes the Qt4 check,
      and remove the check for the Phonon component from the Qt4 check.
      Unfortunately the upstream patch incorrectly attempts to link the
      wrong ${EXT_LIBRARIES} (instead of the correct ${EXT_LIBS}) when
      making the brewtarget executable, so fix that, too. Lastly, pass
      CMAKE_PREFIX_PATH in debian/rules.

 -- Daniel T Chen <crimsun@ubuntu.com>  Sat, 24 Sep 2011 21:17:54 -0400

brewtarget (1.2.3-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Fix build problem.

 -- Chris Taylor <ctaylor@debian.org>  Sat, 16 Apr 2011 06:37:02 +0000

brewtarget (1.2.3-1) unstable; urgency=low

  * 1.2.2 release.
  * New upstream release 1.2.3
  * Initial debian release (Closes: #538751)

 -- Philip G. Lee <rocketman768@gmail.com>  Sat, 01 Jan 2011 20:13:00 -0600
 

=== debian/control ===
Source: brewtarget
Section: misc
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Philip G. Lee <rocketman768@gmail.com>
Build-Depends: cmake (>= 2.8), debhelper (>= 7.0.50), autotools-dev, libqt4-dev, qt4-qmake, libphonon-dev, libqtwebkit-dev
Standards-Version: 3.9.1
Homepage: http://brewtarget.sourceforge.net

Package: brewtarget
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: GUI beer brewing software
 Brewtarget is a calculator for brewing beer. It is a Qt-based program which
 allows you to create recipes from a database of ingredients. It calculates all
 the important parameters, helps you with mash temperatures, and just makes the
 process of recipe formulation much easier.

=== debian/rules ===
#!/usr/bin/make -f
install-dir = "$(shell pwd)/debian/brewtarget"

override_dh_auto_configure:
	if ! test -d build; then mkdir build; fi
	if ! test -d build/cmake; then mkdir build/cmake; fi
	cd build/cmake; \
	cmake ../../ -DDO_RELEASE_BUILD=ON -DCMAKE_INSTALL_PREFIX=$(install-dir) -DEXEC_PREFIX=/usr -DCMAKE_PREFIX_PATH=/usr/include/phonon

override_dh_auto_build:
	cd build/cmake; \
	make

override_dh_auto_install:
	cd build/cmake; \
	make install

override_dh_clean:
	dh_clean
	if test -d build/cmake; then rm -r build/cmake; fi
	if test -e src/config.h; then rm src/config.h; fi
	if test -d debian/brewtarget; then rm -r debian/brewtarget; fi

%:
	dh $@

## brewtarget 1.2.4

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,8 @@
+# The current directory in the original source.
+INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_SOURCE_DIR} )
+# The current directory in the output build directory.
+INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_BINARY_DIR} )
+
 # Put all the required Qt dirs in the includes.
 INCLUDE(${QT_USE_FILE})
 
@@ -8,8 +13,14 @@
     ${SRCDIR}/BeerXMLElement.cpp
     ${SRCDIR}/BrewDayWidget.cpp
     ${SRCDIR}/BrewDayScrollWidget.cpp
+    ${SRCDIR}/brewnote.cpp
+    ${SRCDIR}/BrewNoteWidget.cpp
+    ${SRCDIR}/BrewTargetTreeItem.cpp
+    ${SRCDIR}/BrewTargetTreeModel.cpp
+    ${SRCDIR}/BrewTargetTreeView.cpp
     ${SRCDIR}/BeerColorWidget.cpp
     ${SRCDIR}/brewtarget.cpp
+    ${SRCDIR}/BtSplashScreen.cpp
     ${SRCDIR}/CelsiusTempUnitSystem.cpp
     ${SRCDIR}/ColorMethods.cpp
     ${SRCDIR}/ConverterTool.cpp
@@ -73,6 +84,7 @@
     ${SRCDIR}/TimerWidget.cpp
     ${SRCDIR}/TimeUnitSystem.cpp
     ${SRCDIR}/unit.cpp
+    ${SRCDIR}/UnitSystem.cpp
     ${SRCDIR}/UnitSystems.cpp
     ${SRCDIR}/USVolumeUnitSystem.cpp
     ${SRCDIR}/USWeightUnitSystem.cpp
@@ -100,6 +112,8 @@
     ${UIDIR}/aboutDialog.ui
     ${UIDIR}/brewDayWidget.ui
     ${UIDIR}/brewDayScrollWidget.ui
+    ${UIDIR}/brewNoteWidget.ui
+    ${UIDIR}/btSplashScreen.ui
     ${UIDIR}/converterTool.ui
     ${UIDIR}/mainWindow.ui
     ${UIDIR}/mashStepEditor.ui
@@ -138,7 +152,11 @@
     ${SRCDIR}/BeerColorWidget.h
     ${SRCDIR}/BrewDayWidget.h
     ${SRCDIR}/BrewDayScrollWidget.h
+    ${SRCDIR}/BrewNoteWidget.h
+    ${SRCDIR}/BrewTargetTreeModel.h
+    ${SRCDIR}/BrewTargetTreeView.h
     ${SRCDIR}/BtDigitWidget.h
+    ${SRCDIR}/BtSplashScreen.h
     ${SRCDIR}/ConverterTool.h
     ${SRCDIR}/EquipmentComboBox.h
     ${SRCDIR}/EquipmentEditor.h
@@ -191,81 +209,33 @@
     ${SRCDIR}/YeastTableWidget.h
 )
 
-# List of documentation files to be installed.
-SET( brewtarget_DOCS
-     ${ROOTDIR}/README
-#     ${ROOTDIR}/COPYING.GPLv3
-#     ${ROOTDIR}/COPYING.WTFPL
-     ${ROOTDIR}/COPYRIGHT
-     ${ROOTDIR}/doc/manual/index.html
-)
-
-# List of data files to be installed.
-SET( brewtarget_DATA
-     ${DATADIR}/database.xml
-     ${DATADIR}/mashs.xml
-     ${DATADIR}/options.xml
-     ${DATADIR}/recipes.xml
-)
-
-# Desktop files to install.
-SET( brewtarget_DESKTOP
-     ${ROOTDIR}/brewtarget.desktop
-)
-
-# Icon files to install.
-SET( brewtarget_ICONS
-     ${ROOTDIR}/images/BrewtargetIcon.png
-)
-
-SET( TRANSLATIONS_FILES
-     ${TRANSLATIONSDIR}/bt_cs.ts # Czech
-     ${TRANSLATIONSDIR}/bt_de.ts # German
-     ${TRANSLATIONSDIR}/bt_en.ts # English
-     ${TRANSLATIONSDIR}/bt_es.ts # Spanish
-     ${TRANSLATIONSDIR}/bt_fr.ts # French
-     ${TRANSLATIONSDIR}/bt_pl.ts # Polish
-     ${TRANSLATIONSDIR}/bt_pt.ts # Portuguese
-)
-
 SET( FILES_TO_TRANSLATE
      ${brewtarget_SRCS}
      ${brewtarget_UIS}
 )
 
-SET( RCFILE ${WINDIR}/icon.rc )
-
-SET( brewtarget_SOUNDS
-     ${DATADIR}/sounds/45minLeft.mp3
-     ${DATADIR}/sounds/addFuckinHops.mp3
-     ${DATADIR}/sounds/aromaHops.mp3
-     ${DATADIR}/sounds/bitteringHops.mp3
-     ${DATADIR}/sounds/checkBoil.mp3
-     ${DATADIR}/sounds/checkFirstRunnings.mp3
-     ${DATADIR}/sounds/checkGravity.mp3
-     ${DATADIR}/sounds/checkHydrometer.mp3
-     ${DATADIR}/sounds/checkMashTemps.mp3
-     ${DATADIR}/sounds/checkTemp.mp3
-     ${DATADIR}/sounds/clarifyingAgent.mp3
-     ${DATADIR}/sounds/cleanup.mp3
-     ${DATADIR}/sounds/closeFuckinValves.mp3
-     ${DATADIR}/sounds/closeValves.mp3
-     ${DATADIR}/sounds/doughIn.mp3
-     ${DATADIR}/sounds/drinkAnotherHomebrew.mp3
-     ${DATADIR}/sounds/drinkHomebrew.mp3
-     ${DATADIR}/sounds/emptyMashTun.mp3
-     ${DATADIR}/sounds/extraPropane.mp3
-     ${DATADIR}/sounds/flameout.mp3
-     ${DATADIR}/sounds/flavorHops.mp3
-     ${DATADIR}/sounds/heatWater.mp3
-     ${DATADIR}/sounds/mashHops.mp3
-     ${DATADIR}/sounds/pitchYeast.mp3
-     ${DATADIR}/sounds/sanitize.mp3
-     ${DATADIR}/sounds/sparge.mp3
-     ${DATADIR}/sounds/startBurner.mp3
-     ${DATADIR}/sounds/startChill.mp3
-     ${DATADIR}/sounds/stirMash.mp3
-)
+#==============================Setup the config.h==============================
+
+# "#define CONFIGDATADIR ${CONFIGDATADIR}$" in config.in will be replaced
+# by the below corresponding value in ${CONFIGDATADIR} below when
+# CONFIGURE_FILE() is called.
+IF( IS_ABSOLUTE ${DATAPATH} )
+   SET( CONFIGDATADIR "${DATAPATH}/" )
+ELSE()
+   SET( CONFIGDATADIR "/${DATAPATH}/" )
+ENDIF()
+
+IF( IS_ABSOLUTE ${DOCPATH} )
+   SET( CONFIGDOCDIR "${DOCPATH}/" )
+ELSE()
+   SET( CONFIGDOCDIR "/${DOCPATH}/" )
+ENDIF()
+
+# Tell cmake where the configure file is and where
+# to put the output. All variables in config.in written as "${VAR}$
+# will be replaced by VAR as determined by cmake in config.h.
+# Outputs only in the build directory.
+CONFIGURE_FILE( config.in config.h )
 
 #==================================Qt Junk=====================================
 
@@ -294,63 +264,56 @@
 # the translations as a dependency for the executable later.
 ADD_CUSTOM_TARGET(translations DEPENDS ${QM_FILES})
 
-#===============================Packaging======================================
-
-# NOTE: For now, this only calls CPack when we are unix. Need to add support
-# for apple bundles and microsoft NSIS installer.
-#
-# To make the packages, "make package". For source packages, "make package_source"
-IF(EXISTS "${CMAKE_ROOT}/Modules/CPack.cmake" AND UNIX AND NOT APPLE)
-  MESSAGE(STATUS "CMakeRoot: ${CMAKE_ROOT}/Modules/CPack.cmake")
-
-  SET(CPACK_SET_DESTDIR "on")
-  SET(CPACK_PACKAGING_INSTALL_PREFIX "/tmp")
-  SET(CPACK_SOURCE_GENERATOR "TBZ2;")
-  SET(CPACK_SOURCE_IGNORE_FILES 
-      "/.svn/"
-      "~$"
-      "/CMakeFiles/"
-      "/_CPack_Packages/"
-      "^brewtarget.*deb$"
-      "^brewtarget.*rpm$"
-      "^brewtarget.*tar.*$"
-      "CPack.*"
-      "Makefile"
-      "cmake_install.*"
-      "\\\\.o$"
-      "/brewtarget.dir/"
-      "moc_.*"
-      "qrc_brewtarget.*"
-      "ui_.*h"
-      "install_manifest.*"
-      "config\\\\.h"
+#============================Icon for Windows==================================
+
+IF( WIN32 AND MINGW )
+  ADD_CUSTOM_COMMAND(OUTPUT ${WINDIR}/icon.o
+                     COMMAND windres.exe -I${CMAKE_CURRENT_SOURCE_DIR}
+                     -i${RCFILE}
+                     -o${WINDIR}/icon.o
+                     DEPENDS ${RCFILE}
   )
-
-  SET( CPACK_PACKAGE_VERSION ${brewtarget_VERSION_STRING} )
-  SET( CPACK_PACKAGE_VENDOR  "Philip G. Lee" )
-  SET( CPACK_PACKAGE_CONTACT "Philip G. Lee <rocketman768@gmail.com>" )
-  SET( CPACK_PACKAGE_DESCRIPTION_SUMMARY "GUI beer brewing software" )
-  SET( CPACK_PACKAGE_DESCRIPTION "Brewtarget is a calculator for brewing beer. It is a Qt-based program which
-       allows you to create recipes from a database of ingredients. It calculates all
-       the important parameters, helps you with mash temperatures, and just makes the
-       process of recipe formulation much easier." )
-
-#	SET(CPACK_RESOURCE_FILE_LICENSE		${CMAKE_CURRENT_SOURCE_DIR}//COPYING)
-  SET(CPACK_PACKAGE_VERSION_MAJOR       ${brewtarget_VERSION_MAJOR})
-  SET(CPACK_PACKAGE_VERSION_MINOR       ${brewtarget_VERSION_MINOR})	# to create a debian confirm file-version-string
-  SET(CPACK_PACKAGE_FILE_NAME           "${CMAKE_PROJECT_NAME}_${brewtarget_VERSION_STRING}_${CMAKE_SYSTEM_PROCESSOR}")
-  SET(CPACK_SOURCE_PACKAGE_FILE_NAME    "${CMAKE_PROJECT_NAME}_${brewtarget_VERSION_STRING}_source")
-  SET(CPACK_PACKAGE_EXECUTABLES "${brewtarget_EXECUTABLE}" "Brewtarget" )
-  #SET(CPACK_STRIP_FILES TRUE)
-  SET(CPACK_COMPONENTS_ALL Libraries ApplicationData)
-
- #===========================UNIX======================================
- IF(UNIX)
-  SET(CPACK_GENERATOR "DEB;RPM;TBZ2;")
-
-  #-----------------DEB----------------
-  SET( CPACK_DEBIAN_PACKAGE_MAINTAINER "Philip G. Lee <rocketman768@gmail.com>" )
-  # NOTE: Use the getdependencies script to get the dependencies!
-  SET( CPACK_DEBIAN_PACKAGE_DEPENDS "libc6 (>= 2.3.6-6~), libc6 (>= 2.4), libgcc1 (>= 1:4.1.1), libphonon4 (>= 4:4.2.0), libqt4-dbus (>= 4:4.5.3), libqt4-svg (>= 4:4.5.3), libqt4-webkit (>= 4:4.5.3), libqt4-xml (>= 4:4.5.3), libqtcore4 (>= 4:4.6.1), libqtgui4 (>= 4:4.5.3), libstdc++6 (>= 4.1.1), libx11-6, phonon (>= 4:4.5.2)" )
-
-  SET( CPACK_DEBIAN_PACKAGE_SECTION "misc" )
+  SET(brewtarget_SRCS ${brewtarget_SRCS} ${WINDIR}/icon.o)
+ELSEIF(WIN32)
+  SET(brewtarget_SRCS ${brewtarget_SRCS} ${RCFILE})
+ENDIF()
+
+#===========================Create the binary==================================
+
+ADD_EXECUTABLE( ${brewtarget_EXECUTABLE} ${brewtarget_SRCS} ${brewtarget_MOC_SRCS} ${brewtarget_QRC_CPP} ${brewtarget_UIS_H} )
+ADD_DEPENDENCIES( ${brewtarget_EXECUTABLE} translations )
+
+# Link brewtarget against appropriate libraries.
+IF( WIN32 AND MINGW )
+   ############################################################################
+   # Need to set some linker flags that I don't know how to get
+   # automatically.
+   ############################################################################
+
+   # MinGW-specific flags.
+   #    '-Wl,-subsystem,windows' supresses the output command window.
+   #    '-Wl,-s' strips the executable of symbols.
+   SET_TARGET_PROPERTIES( ${brewtarget_EXECUTABLE} PROPERTIES LINK_FLAGS "-enable-stdcall-fixup -Wl,-enable-auto-import -Wl,-enable-runtime-pseudo-reloc -mthreads -Wl,-subsystem,windows")
+ENDIF()
+
+# Link brewtarget against Qt libraries defined by QT_LIBRARIES
+TARGET_LINK_LIBRARIES( ${brewtarget_EXECUTABLE} ${QT_LIBRARIES} ${EXT_LIBRARIES} )
+MESSAGE( STATUS "Libraries: ${QT_LIBRARIES} ${EXT_LIBRARIES}" )
+
+#=================================Installs=====================================
+
+# Install executable.
+INSTALL( TARGETS ${brewtarget_EXECUTABLE}
+         RUNTIME DESTINATION ${TARGETPATH} )
+
+# Install the translations.
+INSTALL(FILES ${QM_FILES}
+        DESTINATION "${DATAPATH}/translations_qm")
+
+IF( APPLE )
+   # This SHOULD run macdeployqt on the app bundle at install time.
+   # Don't know if it works. Could someone try?
+   # May have to add a WORKING_DIRECTORY.
+   INSTALL( CODE
+            "EXECUTE_PROCESS( COMMAND ${QT_BINARY_DIR}/macdeployqt ${BT_BUNDLE_DIR} )" )
+ENDIF()

=== debian/changelog ===
brewtarget (1.2.4-1) unstable; urgency=low

  * New upstream release
  * Added build-dep on libqtwebkit-dev

 -- Philip G. Lee <rocketman768@gmail.com>  Sun, 02 Oct 2011 12:23:44 -0500

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,9 @@
 Source: brewtarget
 Section: misc
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Philip G. Lee <rocketman768@gmail.com>
+Maintainer: Philip G. Lee <rocketman768@gmail.com>
 Build-Depends: cmake (>= 2.8), debhelper (>= 7.0.50), autotools-dev, libqt4-dev, qt4-qmake, libphonon-dev, libqtwebkit-dev
-Standards-Version: 3.9.1
+Standards-Version: 3.9.2
 Homepage: http://brewtarget.sourceforge.net
 
 Package: brewtarget

=== debian/rules ===
--- 
+++ 
@@ -5,7 +5,7 @@
 	if ! test -d build; then mkdir build; fi
 	if ! test -d build/cmake; then mkdir build/cmake; fi
 	cd build/cmake; \
-	cmake ../../ -DDO_RELEASE_BUILD=ON -DCMAKE_INSTALL_PREFIX=$(install-dir) -DEXEC_PREFIX=/usr -DCMAKE_PREFIX_PATH=/usr/include/phonon
+	cmake ../../ -DDO_RELEASE_BUILD=ON -DCMAKE_INSTALL_PREFIX=$(install-dir) -DEXEC_PREFIX=usr
 
 override_dh_auto_build:
 	cd build/cmake; \
@@ -23,3 +23,4 @@
 
 %:
 	dh $@
+
